Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.google.common.collect
Class ConcurrentHashMultiset<E>

    java.lang.Object
      java.util.AbstractCollection<E>
          com.google.common.collect.ConcurrentHashMultiset<E>

All Implemented Interfaces:
  Multiset<E>, Serializable, Iterable<E>, Collection<E>

    public final class ConcurrentHashMultiset<E>

extends AbstractCollection<E>
implements Serializable

A multiset that supports concurrent modifications and that provides atomic versions of most `Multiset` operations (exceptions where noted). Null elements are not supported.

Since:
  2.0 (imported from Google Collections Library)
Author:
  Cliff L. Biffle, mike nonemacher
See Also:
  Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from interface com.google.common.collect.Multiset
`Multiset.Entry<E>`

Method Summary
`boolean` | `add(E element)` Adds a single occurrence of the specified element to this multiset.
`int` | `add(E element, int occurrences)` Adds a number of occurrences of the specified element to this multiset.
`boolean` | `addAll(Collection<? extends E> elementsToAdd)`
`void` | `clear()`
`boolean` | `contains(Object element)` Determines whether this multiset contains the specified element.
`int` | `count(Object element)` Returns the number of occurrences of `element` in this multiset.
`static
`<E> ConcurrentHashMultiset<E>`
` | `create()` Creates a new, empty `ConcurrentHashMultiset` using the default initial capacity, load factor, and concurrency settings.
`static
`<E> ConcurrentHashMultiset<E>`
` | `create(GenericMapMaker<? super E,? super Number> mapMaker)` Creates a new, empty `ConcurrentHashMultiset` using `mapMaker` to construct the internal backing map.
`static
`<E> ConcurrentHashMultiset<E>`
` | `create(Iterable<? extends E> elements)` Creates a new `ConcurrentHashMultiset` containing the specified elements, using the default initial capacity, load factor, and concurrency settings.
`Set<E>` | `elementSet()` Returns the set of distinct elements contained in this multiset.
`Set<Multiset.Entry<E>>` | `entrySet()` Returns a view of the contents of this multiset, grouped into `Multiset.Entry` instances, each providing an element of the multiset and the count of that element.
`boolean` | `equals(Object object)` Compares the specified object with this multiset for equality.
`int` | `hashCode()` Returns the hash code for this multiset.
`boolean` | `isEmpty()`
`Iterator<E>` | `iterator()`
`boolean` | `remove(Object element)` Removes a single occurrence of the specified element from this multiset, if present.
`int` | `remove(Object element, int occurrences)` Removes a number of occurrences of the specified element from this multiset.
`boolean` | `removeAll(Collection<?> elementsToRemove)`
`boolean` | `removeExactly(Object element, int occurrences)` Removes exactly the specified number of occurrences of `element`, or makes no change if this is not possible.
`boolean` | `retainAll(Collection<?> elementsToRetain)`
`int` | `setCount(E element, int count)` Adds or removes occurrences of `element` such that the `count(java.lang.Object)` of the element becomes `count`.
`boolean` | `setCount(E element, int expectedOldCount, int newCount)` Sets the number of occurrences of `element` to `newCount`, but only if the count is currently `expectedOldCount`.
`int` | `size()`
`Object[]` | `toArray()`
`
`<T> T[]`
` | `toArray(T[] array)`
`String` | `toString()`

Methods inherited from class java.util.AbstractCollection
`containsAll`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface com.google.common.collect.Multiset
`containsAll`

Method Detail

### create

    public static <E> ConcurrentHashMultiset<E> create()

  Creates a new, empty `ConcurrentHashMultiset` using the default initial capacity, load factor, and concurrency settings.

### create

    public static <E> ConcurrentHashMultiset<E> create(Iterable<? extends E> elements)

  Creates a new `ConcurrentHashMultiset` containing the specified elements, using the default initial capacity, load factor, and concurrency settings.

  This implementation is highly efficient when `elements` is itself a `Multiset`.

  Parameters:
    `elements` - the elements that the multiset should contain

### create

    @Beta
    public static <E> ConcurrentHashMultiset<E> create(GenericMapMaker<? super E,? super Number> mapMaker)

  Creates a new, empty `ConcurrentHashMultiset` using `mapMaker` to construct the internal backing map.

  If this `MapMaker` is configured to use entry eviction of any kind, this eviction applies to all occurrences of a given element as a single unit. However, most updates to the multiset do not count as map updates at all, since we're usually just mutating the value stored in the map, so `MapMaker.expireAfterAccess(long, java.util.concurrent.TimeUnit)` makes sense (evict the entry that was queried or updated longest ago), but `MapMaker.expireAfterWrite(long, java.util.concurrent.TimeUnit)` doesn't, because the eviction time is measured from when we saw the first occurrence of the object.

  The returned multiset is serializable but any serialization caveats given in `MapMaker` apply.

  Finally, soft/weak values can be used but are not very useful: the values are created internally and not exposed externally, so no one else will have a strong reference to the values. Weak keys on the other hand can be useful in some scenarios.

  Since:
    7.0

### count

    public int count(@Nullable
                     Object element)

  Returns the number of occurrences of `element` in this multiset.

  Specified by:
    `count` in interface `Multiset<E>`
  Parameters:
    `element` - the element to look for
  Returns:
    the nonnegative number of occurrences of the element

### size

    public int size()

  If the data in the multiset is modified by any other threads during this method, it is undefined which (if any) of these modifications will be reflected in the result.

  Specified by:
    `size` in interface `Collection<E>`

### toArray

    public Object[] toArray()

  Specified by:
    `toArray` in interface `Collection<E>`
  Overrides:
    `toArray` in class `AbstractCollection<E>`

### toArray

    public <T> T[] toArray(T[] array)

  Specified by:
    `toArray` in interface `Collection<E>`
  Overrides:
    `toArray` in class `AbstractCollection<E>`

### add

    public int add(E element,
                   int occurrences)

  Adds a number of occurrences of the specified element to this multiset.

  Specified by:
    `add` in interface `Multiset<E>`
  Parameters:
    `element` - the element to add
    `occurrences` - the number of occurrences to add
  Returns:
    the previous count of the element before the operation; possibly zero
  Throws:
    `IllegalArgumentException` - if `occurrences` is negative, or if the resulting amount would exceed `Integer.MAX_VALUE`

### remove

    public int remove(@Nullable
                      Object element,
                      int occurrences)

  Removes a number of occurrences of the specified element from this multiset. If the multiset contains fewer than this number of occurrences to begin with, all occurrences will be removed.

  Specified by:
    `remove` in interface `Multiset<E>`
  Parameters:
    `element` - the element whose occurrences should be removed
    `occurrences` - the number of occurrences of the element to remove
  Returns:
    the count of the element before the operation; possibly zero
  Throws:
    `IllegalArgumentException` - if `occurrences` is negative

### removeExactly

    public boolean removeExactly(@Nullable
                                 Object element,
                                 int occurrences)

  Removes exactly the specified number of occurrences of `element`, or makes no change if this is not possible.

  This method, in contrast to `remove(Object, int)`, has no effect when the element count is smaller than `occurrences`.

  Parameters:
    `element` - the element to remove
    `occurrences` - the number of occurrences of `element` to remove
  Returns:
    `true` if the removal was possible (including if `occurrences` is zero)

### setCount

    public int setCount(E element,
                        int count)

  Adds or removes occurrences of `element` such that the `count(java.lang.Object)` of the element becomes `count`.

  Specified by:
    `setCount` in interface `Multiset<E>`
  Parameters:
    `element` - the element to add or remove occurrences of; may be null only if explicitly allowed by the implementation
    `count` - the desired count of the element in this multiset
  Returns:
    the count of `element` in the multiset before this call
  Throws:
    `IllegalArgumentException` - if `count` is negative

### setCount

    public boolean setCount(E element,
                            int expectedOldCount,
                            int newCount)

  Sets the number of occurrences of `element` to `newCount`, but only if the count is currently `expectedOldCount`. If `element` does not appear in the multiset exactly `expectedOldCount` times, no changes will be made.

  Specified by:
    `setCount` in interface `Multiset<E>`
  Parameters:
    `element` - the element to conditionally set the count of; may be null only if explicitly allowed by the implementation
    `expectedOldCount` - the expected present count of the element in this multiset
    `newCount` - the desired count of the element in this multiset
  Returns:
    `true` if the change was successful. This usually indicates that the multiset has been modified, but not always: in the case that `expectedOldCount == newCount`, the method will return `true` if the condition was met.
  Throws:
    `IllegalArgumentException` - if `expectedOldCount` or `newCount` is negative

### entrySet

    public Set<Multiset.Entry<E>> entrySet()

  Description copied from interface: `Multiset`
  Returns a view of the contents of this multiset, grouped into `Multiset.Entry` instances, each providing an element of the multiset and the count of that element. This set contains exactly one entry for each distinct element in the multiset (thus it always has the same size as the `Multiset.elementSet()`). The order of the elements in the element set is unspecified.

  The entry set is backed by the same data as the multiset, so any change to either is immediately reflected in the other. However, multiset changes may or may not be reflected in any `Entry` instances already retrieved from the entry set (this is implementation-dependent). Furthermore, implementations are not required to support modifications to the entry set at all, and the `Entry` instances themselves don't even have methods for modification. See the specific implementation class for more details on how its entry set handles modifications.

  Specified by:
    `entrySet` in interface `Multiset<E>`
  Returns:
    a set of entries representing the data of this multiset

### isEmpty

    public boolean isEmpty()

  Specified by:
    `isEmpty` in interface `Collection<E>`

### clear

    public void clear()

  Specified by:
    `clear` in interface `Collection<E>`

### contains

    public boolean contains(@Nullable
                            Object element)

  Description copied from interface: `Multiset`
  Determines whether this multiset contains the specified element.

  This method refines `Collection.contains(java.lang.Object)` to further specify that it may not throw an exception in response to `element` being null or of the wrong type.

  Specified by:
    `contains` in interface `Multiset<E>`
  Specified by:
    `contains` in interface `Collection<E>`
  Overrides:
    `contains` in class `AbstractCollection<E>`
  Parameters:
    `element` - the element to check for
  Returns:
    `true` if this multiset contains at least one occurrence of the element

### iterator

    public Iterator<E> iterator()

  Description copied from interface: `Multiset`

  Elements that occur multiple times in the multiset will appear multiple times in this iterator, though not necessarily sequentially.

  Specified by:
    `iterator` in interface `Multiset<E>`
  Specified by:
    `iterator` in interface `Iterable<E>`
  Specified by:
    `iterator` in interface `Collection<E>`
  Specified by:
    `iterator` in class `AbstractCollection<E>`

### add

    public boolean add(@Nullable
                       E element)

  Description copied from interface: `Multiset`
  Adds a single occurrence of the specified element to this multiset.

  This method refines `Collection.add(E)`, which only ensures the presence of the element, to further specify that a successful call must always increment the count of the element, and the overall size of the collection, by one.

  Specified by:
    `add` in interface `Multiset<E>`
  Specified by:
    `add` in interface `Collection<E>`
  Overrides:
    `add` in class `AbstractCollection<E>`
  Parameters:
    `element` - the element to add one occurrence of; may be null only if explicitly allowed by the implementation
  Returns:
    `true` always, since this call is required to modify the multiset, unlike other `Collection` types

### remove

    public boolean remove(Object element)

  Description copied from interface: `Multiset`
  Removes a single occurrence of the specified element from this multiset, if present.

  This method refines `Collection.remove(java.lang.Object)` to further specify that it may not throw an exception in response to `element` being null or of the wrong type.

  Specified by:
    `remove` in interface `Multiset<E>`
  Specified by:
    `remove` in interface `Collection<E>`
  Overrides:
    `remove` in class `AbstractCollection<E>`
  Parameters:
    `element` - the element to remove one occurrence of
  Returns:
    `true` if an occurrence was found and removed

### addAll

    public boolean addAll(Collection<? extends E> elementsToAdd)

  This implementation is highly efficient when `elementsToAdd` is itself a `Multiset`.

  Specified by:
    `addAll` in interface `Collection<E>`
  Overrides:
    `addAll` in class `AbstractCollection<E>`

### removeAll

    public boolean removeAll(Collection<?> elementsToRemove)

  Description copied from interface: `Multiset`

  Note: This method ignores how often any element might appear in `c`, and only cares whether or not an element appears at all. If you wish to remove one occurrence in this multiset for every occurrence in `c`, see `Multisets.removeOccurrences(Multiset, Multiset)`.

  This method refines `Collection.removeAll(java.util.Collection)` to further specify that it may not throw an exception in response to any of `elements` being null or of the wrong type.

  Specified by:
    `removeAll` in interface `Multiset<E>`
  Specified by:
    `removeAll` in interface `Collection<E>`
  Overrides:
    `removeAll` in class `AbstractCollection<E>`

### retainAll

    public boolean retainAll(Collection<?> elementsToRetain)

  Description copied from interface: `Multiset`

  Note: This method ignores how often any element might appear in `c`, and only cares whether or not an element appears at all. If you wish to remove one occurrence in this multiset for every occurrence in `c`, see `Multisets.retainOccurrences(Multiset, Multiset)`.

  This method refines `Collection.retainAll(java.util.Collection)` to further specify that it may not throw an exception in response to any of `elements` being null or of the wrong type.

  Specified by:
    `retainAll` in interface `Multiset<E>`
  Specified by:
    `retainAll` in interface `Collection<E>`
  Overrides:
    `retainAll` in class `AbstractCollection<E>`
  See Also:
    `Multisets.retainOccurrences(Multiset, Multiset)`

### elementSet

    public Set<E> elementSet()

  Description copied from interface: `Multiset`
  Returns the set of distinct elements contained in this multiset. The element set is backed by the same data as the multiset, so any change to either is immediately reflected in the other. The order of the elements in the element set is unspecified.

  If the element set supports any removal operations, these necessarily cause all occurrences of the removed element(s) to be removed from the multiset. Implementations are not expected to support the add operations, although this is possible.

  A common use for the element set is to find the number of distinct elements in the multiset: `elementSet().size()`.

  Specified by:
    `elementSet` in interface `Multiset<E>`
  Returns:
    a view of the set of distinct elements in this multiset

### equals

    public boolean equals(@Nullable
                          Object object)

  Compares the specified object with this multiset for equality. Returns `true` if the given object is also a multiset and contains equal elements with equal counts, regardless of order.

  This implementation returns `true` if `object` is a multiset of the same size and if, for each element, the two multisets have the same count.

  Specified by:
    `equals` in interface `Multiset<E>`
  Specified by:
    `equals` in interface `Collection<E>`
  Overrides:
    `equals` in class `Object`

### hashCode

    public int hashCode()

  Returns the hash code for this multiset. This is defined as the sum of

         ((element == null) ? 0 : element.hashCode()) ^ count(element)

  over all distinct elements in the multiset. It follows that a multiset and its entry set always have the same hash code.

  This implementation returns the hash code of `Multiset.entrySet()`.

  Specified by:
    `hashCode` in interface `Multiset<E>`
  Specified by:
    `hashCode` in interface `Collection<E>`
  Overrides:
    `hashCode` in class `Object`

### toString

    public String toString()

  It is recommended, though not mandatory, that this method return the result of invoking `Multiset.toString()` on the `Multiset.entrySet()`, yielding a result such as `[a x 3, c, d x 2, e]`.

  This implementation returns the result of invoking `toString` on `Multiset.entrySet()`.

  Specified by:
    `toString` in interface `Multiset<E>`
  Overrides:
    `toString` in class `AbstractCollection<E>`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2010-2011. All Rights Reserved.